TableSheet Panel

The TableSheet Panel supports showing/hiding and reordering columns of a TableSheet.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

A TableSheet has an interactive TableSheet Panel.

Create a TableSheet Panel:

//init a table sheet panel
var host = document.getElementById("panel");
var panel = new GC.Spread.Sheets.TableSheet.TableSheetPanel("myPanel", myTableSheet, host);
//init a table sheet panel with options
var host = document.getElementById("panel");
var options = { showSource: GC.Spread.Sheets.TableSheet.ShowSourceOptions.all };
var panel = new GC.Spread.Sheets.TableSheet.TableSheetPanel("myPanel", myTableSheet, host, options);

The constructor of the TableSheet Panel has 4 parameters:

Parameter Type Description
name string The table sheet panel name.
tableSheet GC.Spread.Sheets.TableSheet.TableSheet The table sheet.
host HTMLElement The host element.
options Object The initialization options.
options.showSource GC.Spread.Sheets.TableSheet.ShowSourceOptions How to show a column value.

The enum GC.Spread.Sheets.TableSheet.ShowSourceOptions has 4 options.

Key Value Description
none 0 Doesn't show a column value.
field 1 Shows a column value when it is own field or related field.
formula 2 Shows a column value when it is calculated field.
all 3 Shows a column value, no matter it is own field, related field, or calculated field.

Attaching a TableSheet Panel to a TableSheet:

/**
  * Attaches a table sheet into current table sheet panel.
  * @param {GC.Spread.Sheets.TableSheet.TableSheet} tableSheet The table sheet.
  * @example
  * //This example attaches a table sheet.
  * panel.attach(tableSheet);
  */
 attach(tableSheet: GC.Spread.Sheets.TableSheet.TableSheet): void;

Detaching the TableSheet Panel from the TableSheet:

/**
  * Detaches a table sheet from current table sheet panel.
  * @example
  * //This example detaches a table sheet.
  * panel.detach();
  */
 detach(): void;

Destroying the TableSheet Panel:

/**
  * Destroys current table sheet panel.
  * @example
  * //This example destroys current table sheet panel.
  * panel.destroy();
  */
 destroy(): void;

Find a TableSheet Panel by its host element:

/**
  * Finds a table sheet panel by a DOM element.
  * @param {HTMLElement | string} host The host element.
  * @example
  * //This example finds a table sheet panel by a DOM element.
  * GC.Spread.Sheets.TableSheet.TableSheetPanel.findControl(document.getElementById("sampleDiv"));
  */
 static findControl(host: HTMLElement|string): GC.Spread.Sheets.TableSheet.TableSheetPanel;
A TableSheet has an interactive TableSheet Panel. Create a TableSheet Panel: The constructor of the TableSheet Panel has 4 parameters: Parameter Type Description name string The table sheet panel name. tableSheet GC.Spread.Sheets.TableSheet.TableSheet The table sheet. host HTMLElement The host element. options Object The initialization options. options.showSource GC.Spread.Sheets.TableSheet.ShowSourceOptions How to show a column value. The enum GC.Spread.Sheets.TableSheet.ShowSourceOptions has 4 options. Key Value Description none 0 Doesn't show a column value. field 1 Shows a column value when it is own field or related field. formula 2 Shows a column value when it is calculated field. all 3 Shows a column value, no matter it is own field, related field, or calculated field. Attaching a TableSheet Panel to a TableSheet: Detaching the TableSheet Panel from the TableSheet: Destroying the TableSheet Panel: Find a TableSheet Panel by its host element:
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ window.onload = function() { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 }); initSpread(spread); }; function initSpread(spread) { spread.suspendPaint(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var baseApiUrl = getBaseApiUrl(); var dataManager = spread.dataManager(); var orderTable = dataManager.addTable("orderTable", { remote: { read: { url: baseApiUrl + "/Order" } } }); var customerTable = dataManager.addTable("customerTable", { remote: { read: { url: baseApiUrl + "/Customer" } } }); dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders"); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet var style = { formatter: 'MM/dd/yyyy' }; var view = orderTable.addView("myView", [ { value: "Id", width: 80 }, { value: "CustomerId", width: 120 }, { value: "ShipName", width: 100 }, { value: "EmployeeId", width: 120 }, { value: "OrderDate", width: 100, style: style }, { value: "RequiredDate", width: 120, style: style }, { value: "ShippedDate", width: 120, style: style }, { value: "ShipVia", width: 80 }, { value: "Freight", width: 80 }, { value: "ShipAddress", width: 120 }, { value: "ShipCity", width: 100 }, { value: "ShipRegion", width: 100 }, { value: "ShipPostalCode", width: 140 }, { value: "ShipState", width: 120 }, { value: "customer", width: 120, isRelationship: true, visible: false }, { value: "customer.Id", width: 120, isRelationship: true, visible: false }, { value: "customer.CompanyName", width: 120, isRelationship: true, visible: false }, { value: "customer.ContactName", width: 120, isRelationship: true, visible: false }, { value: "customer.ContactTitle", width: 120, isRelationship: true, visible: false }, { value: "customer.Address", width: 120, isRelationship: true, visible: false }, { value: "customer.City", width: 120, isRelationship: true, visible: false }, { value: "customer.Region", width: 120, isRelationship: true, visible: false }, { value: "customer.PostalCode", width: 120, isRelationship: true, visible: false }, { value: "customer.State", width: 120, isRelationship: true, visible: false }, { value: "customer.Phone", width: 120, isRelationship: true, visible: false }, ]); view.fetch().then(function() { sheet.setDataView(view); //init a table sheet panel var host = document.getElementById("panel"); var panel = new GC.Spread.Sheets.TableSheet.TableSheetPanel("myPanel", sheet, host); }); spread.resumePaint(); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill --> <script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div id="panel" class="container"> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; margin: 0; } .sample-spreadsheets { width: calc(100% - 303px); height: 100%; overflow: hidden; float: left; } .container { width: 300px; height: 100%; float: left; border: 1px solid lightgrey; }

A TableSheet has an interactive TableSheet Panel.
Create a TableSheet Panel:
The constructor of the TableSheet Panel has 4 parameters:
Parameter
Type
Description
name
string
The table sheet panel name.
tableSheet
GC.Spread.Sheets.TableSheet.TableSheet
The table sheet.
host
HTMLElement
The host element.
options
Object
The initialization options.
options.showSource
GC.Spread.Sheets.TableSheet.ShowSourceOptions
How to show a column value.
The enum GC.Spread.Sheets.TableSheet.ShowSourceOptions has 4 options.
Key
Value
Description
none
0
Doesn't show a column value.
field
1
Shows a column value when it is own field or related field.
formula
2
Shows a column value when it is calculated field.
all
3
Shows a column value, no matter it is own field, related field, or calculated field.
Attaching a TableSheet Panel to a TableSheet:
Detaching the TableSheet Panel from the TableSheet:
Destroying the TableSheet Panel:
Find a TableSheet Panel by its host element:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div id="panel" class="container">
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref } from "vue";
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-vue";
const spreadRef = ref(null);
function initSpread(spread) {
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add order table
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: baseApiUrl + "/Order"
}
}
});
//add customer table
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: baseApiUrl + "/Customer"
}
}
});
//add relationship between order table and customer table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(
0,
"TableSheet1",
GC.Spread.Sheets.SheetType.tableSheet
);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
var style = {
formatter: 'MM/dd/yyyy'
};
var view = orderTable.addView("myView", [
{ value: "Id", width: 80 },
{ value: "CustomerId", width: 120 },
{ value: "ShipName", width: 100 },
{ value: "EmployeeId", width: 120 },
{ value: "OrderDate", width: 100, style: style },
{ value: "RequiredDate", width: 120, style: style },
{ value: "ShippedDate", width: 120, style: style },
{ value: "ShipVia", width: 80 },
{ value: "Freight", width: 80 },
{ value: "ShipAddress", width: 120 },
{ value: "ShipCity", width: 100 },
{ value: "ShipRegion", width: 100 },
{ value: "ShipPostalCode", width: 140 },
{ value: "ShipState", width: 120 },
{ value: "customer", width: 120, isRelationship: true, visible: false },
{ value: "customer.Id", width: 120, isRelationship: true, visible: false },
{ value: "customer.CompanyName", width: 120, isRelationship: true, visible: false },
{ value: "customer.ContactName", width: 120, isRelationship: true, visible: false },
{ value: "customer.ContactTitle", width: 120, isRelationship: true, visible: false },
{ value: "customer.Address", width: 120, isRelationship: true, visible: false },
{ value: "customer.City", width: 120, isRelationship: true, visible: false },
{ value: "customer.Region", width: 120, isRelationship: true, visible: false },
{ value: "customer.PostalCode", width: 120, isRelationship: true, visible: false },
{ value: "customer.State", width: 120, isRelationship: true, visible: false },
{ value: "customer.Phone", width: 120, isRelationship: true, visible: false },
]); //the View has all default columns of the Table
view.fetch().then(function () {
sheet.setDataView(view);
//init a table sheet panel
var host = document.getElementById("panel");
var panel = new GC.Spread.Sheets.TableSheet.TableSheetPanel("myPanel", sheet, host);
});
spread.resumePaint();
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 303px);
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
.container {
width: 300px;
height: 100%;
float: left;
border: 1px solid lightgrey;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

A TableSheet has an interactive TableSheet Panel.
Create a TableSheet Panel:
The constructor of the TableSheet Panel has 4 parameters:
Parameter
Type
Description
name
string
The table sheet panel name.
tableSheet
GC.Spread.Sheets.TableSheet.TableSheet
The table sheet.
host
HTMLElement
The host element.
options
Object
The initialization options.
options.showSource
GC.Spread.Sheets.TableSheet.ShowSourceOptions
How to show a column value.
The enum GC.Spread.Sheets.TableSheet.ShowSourceOptions has 4 options.
Key
Value
Description
none
0
Doesn't show a column value.
field
1
Shows a column value when it is own field or related field.
formula
2
Shows a column value when it is calculated field.
all
3
Shows a column value, no matter it is own field, related field, or calculated field.
Attaching a TableSheet Panel to a TableSheet:
Detaching the TableSheet Panel from the TableSheet:
Destroying the TableSheet Panel:
Find a TableSheet Panel by its host element:
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: 'calc(100% - 303px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
let spread = $event.spread;
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add order table
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: baseApiUrl + "/Order"
}
}
});
//add customer table
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: baseApiUrl + "/Customer"
}
}
});
//add relationship between order table and customer table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
var style = { formatter: 'MM/dd/yyyy' };
var view = orderTable.addView("myView", [
{ value: "Id", width: 80 },
{ value: "CustomerId", width: 120 },
{ value: "ShipName", width: 100 },
{ value: "EmployeeId", width: 120 },
{ value: "OrderDate", width: 100, style: style },
{ value: "RequiredDate", width: 120, style: style },
{ value: "ShippedDate", width: 120, style: style },
{ value: "ShipVia", width: 80 },
{ value: "Freight", width: 80 },
{ value: "ShipAddress", width: 120 },
{ value: "ShipCity", width: 100 },
{ value: "ShipRegion", width: 100 },
{ value: "ShipPostalCode", width: 140 },
{ value: "ShipState", width: 120 },
{ value: "customer", width: 120, isRelationship: true, visible: false },
{ value: "customer.Id", width: 120, isRelationship: true, visible: false },
{ value: "customer.CompanyName", width: 120, isRelationship: true, visible: false },
{ value: "customer.ContactName", width: 120, isRelationship: true, visible: false },
{ value: "customer.ContactTitle", width: 120, isRelationship: true, visible: false },
{ value: "customer.Address", width: 120, isRelationship: true, visible: false },
{ value: "customer.City", width: 120, isRelationship: true, visible: false },
{ value: "customer.Region", width: 120, isRelationship: true, visible: false },
{ value: "customer.PostalCode", width: 120, isRelationship: true, visible: false },
{ value: "customer.State", width: 120, isRelationship: true, visible: false },
{ value: "customer.Phone", width: 120, isRelationship: true, visible: false },
]); //the View has all default columns of the Table
view.fetch().then(function() {
sheet.setDataView(view);
//init a table sheet panel
var host = document.getElementById("panel");
var panel = new GC.Spread.Sheets.TableSheet.TableSheetPanel("myPanel", sheet, host);
});
spread.resumePaint();
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div id="panel" class="container"></div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
.container {
width: 300px;
height: 100%;
float: left;
border: 1px solid lightgrey;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

A TableSheet has an interactive TableSheet Panel.
Create a TableSheet Panel:
The constructor of the TableSheet Panel has 4 parameters:
Parameter
Type
Description
name
string
The table sheet panel name.
tableSheet
GC.Spread.Sheets.TableSheet.TableSheet
The table sheet.
host
HTMLElement
The host element.
options
Object
The initialization options.
options.showSource
GC.Spread.Sheets.TableSheet.ShowSourceOptions
How to show a column value.
The enum GC.Spread.Sheets.TableSheet.ShowSourceOptions has 4 options.
Key
Value
Description
none
0
Doesn't show a column value.
field
1
Shows a column value when it is own field or related field.
formula
2
Shows a column value when it is calculated field.
all
3
Shows a column value, no matter it is own field, related field, or calculated field.
Attaching a TableSheet Panel to a TableSheet:
Detaching the TableSheet Panel from the TableSheet:
Destroying the TableSheet Panel:
Find a TableSheet Panel by its host element:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
export function AppFunc() {
const initSpread = (spread) => {
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add order table
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: baseApiUrl + "/Order"
}
}
});
//add customer table
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: baseApiUrl + "/Customer"
}
}
});
//add relationship between order table and customer table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
var style = { formatter: 'MM/dd/yyyy' };
var view = orderTable.addView("myView", [
{ value: "Id", width: 80 },
{ value: "CustomerId", width: 120 },
{ value: "ShipName", width: 100 },
{ value: "EmployeeId", width: 120 },
{ value: "OrderDate", width: 100, style: style },
{ value: "RequiredDate", width: 120, style: style },
{ value: "ShippedDate", width: 120, style: style },
{ value: "ShipVia", width: 80 },
{ value: "Freight", width: 80 },
{ value: "ShipAddress", width: 120 },
{ value: "ShipCity", width: 100 },
{ value: "ShipRegion", width: 100 },
{ value: "ShipPostalCode", width: 140 },
{ value: "ShipState", width: 120 },
{ value: "customer", width: 120, isRelationship: true, visible: false },
{ value: "customer.Id", width: 120, isRelationship: true, visible: false },
{ value: "customer.CompanyName", width: 120, isRelationship: true, visible: false },
{ value: "customer.ContactName", width: 120, isRelationship: true, visible: false },
{ value: "customer.ContactTitle", width: 120, isRelationship: true, visible: false },
{ value: "customer.Address", width: 120, isRelationship: true, visible: false },
{ value: "customer.City", width: 120, isRelationship: true, visible: false },
{ value: "customer.Region", width: 120, isRelationship: true, visible: false },
{ value: "customer.PostalCode", width: 120, isRelationship: true, visible: false },
{ value: "customer.State", width: 120, isRelationship: true, visible: false },
{ value: "customer.Phone", width: 120, isRelationship: true, visible: false },
]); //the View has all default columns of the Table
view.fetch().then(function () {
sheet.setDataView(view);
//init a table sheet panel
var host = document.getElementById("panel");
var panel = new GC.Spread.Sheets.TableSheet.TableSheetPanel("myPanel", sheet, host);
});
spread.resumePaint();
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div id="panel" class="container"></div>
</div>
);
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div id="panel" class="container"></div>
</div>
);
}
initSpread(spread) {
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add order table
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: baseApiUrl + "/Order"
}
}
});
//add customer table
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: baseApiUrl + "/Customer"
}
}
});
//add relationship between order table and customer table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
var style = { formatter: 'MM/dd/yyyy' };
var view = orderTable.addView("myView", [
{ value: "Id", width: 80 },
{ value: "CustomerId", width: 120 },
{ value: "ShipName", width: 100 },
{ value: "EmployeeId", width: 120 },
{ value: "OrderDate", width: 100, style: style },
{ value: "RequiredDate", width: 120, style: style },
{ value: "ShippedDate", width: 120, style: style },
{ value: "ShipVia", width: 80 },
{ value: "Freight", width: 80 },
{ value: "ShipAddress", width: 120 },
{ value: "ShipCity", width: 100 },
{ value: "ShipRegion", width: 100 },
{ value: "ShipPostalCode", width: 140 },
{ value: "ShipState", width: 120 },
{ value: "customer", width: 120, isRelationship: true, visible: false },
{ value: "customer.Id", width: 120, isRelationship: true, visible: false },
{ value: "customer.CompanyName", width: 120, isRelationship: true, visible: false },
{ value: "customer.ContactName", width: 120, isRelationship: true, visible: false },
{ value: "customer.ContactTitle", width: 120, isRelationship: true, visible: false },
{ value: "customer.Address", width: 120, isRelationship: true, visible: false },
{ value: "customer.City", width: 120, isRelationship: true, visible: false },
{ value: "customer.Region", width: 120, isRelationship: true, visible: false },
{ value: "customer.PostalCode", width: 120, isRelationship: true, visible: false },
{ value: "customer.State", width: 120, isRelationship: true, visible: false },
{ value: "customer.Phone", width: 120, isRelationship: true, visible: false },
]); //the View has all default columns of the Table
view.fetch().then(function () {
sheet.setDataView(view);
//init a table sheet panel
var host = document.getElementById("panel");
var panel = new GC.Spread.Sheets.TableSheet.TableSheetPanel("myPanel", sheet, host);
});
spread.resumePaint();
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 303px);
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
.container {
width: 300px;
height: 100%;
float: left;
border: 1px solid lightgrey;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);